/*
 * PM - 2016
 * lab0.c
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <string.h>

/* poz_x = coordonate verticala
   poz_y = coordonate orizontala */
int poz_x[100], poz_y[100];
int dimSnake = 0;
int miscareStanga = 1, miscareDreapta = 0, miscareSus = 0, miscareJos = 0;

int BUTON_SUS = 0, BUTON_JOS = 0, BUTON_STANGA = 0, BUTON_DREAPTA = 0;

void init(){
	/* setez liniile ca iesire */
	/* 0 - 4 */
	DDRD |= (1 << PD5);
	DDRD |= (1 << PD4);
	DDRD |= (1 << PD3);
	DDRD |= (1 << PD2);
	DDRD |= (1 << PD1);
	
	/* 5 - 9 */
	DDRB |= (1 << PB7);
	DDRB |= (1 << PB6);
	DDRB |= (1 << PB5);
	DDRB |= (1 << PB4);
	DDRB |= (1 << PB3);
	
	/* setez butoanele ca intrare */
	DDRA &= ~ (1 << PA7);
	DDRA &= ~ (1 << PA6);
	DDRA &= ~ (1 << PA5);
	DDRA &= ~ (1 << PA4);
	
	/* activez rezistenta de pull-up */
	PORTA |= (1 << PA7);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA4);
	
	/* setez SER_IN, ST_CP, SH_CP ca iesire */
	/* reg 1 */
	DDRC |= (1 << PC0);
	DDRC |= (1 << PC1);
	DDRC |= (1 << PC2);
	
	/* reg 2 */
	DDRC |= (1 << PC3);
	DDRC |= (1 << PC4);
	DDRC |= (1 << PC5);
	
	/* initializare primele pozitii snake */
	/* prima pozitie "capul sarpelui" */
	poz_x[0] = 3;
	poz_y[0] = 3;
	
	poz_x[1] = 4;
	poz_y[1] = 3;
	
	poz_x[2] = 5;
	poz_y[2] = 3;
	
	/* lungimea sarpelui */
	dimSnake = 3;
}

/* metoda verifica ce butoane au fost apasate */
void press_button(){

	if ((PINA & (1 << PA4)) == 0) {
		BUTON_DREAPTA = 1;
	}
	
	if ((PINA & (1 << PA5)) == 0) {
		BUTON_JOS = 1;
	}
	
	if ((PINA & (1 << PA6)) == 0) {
		BUTON_STANGA = 1;
	}	
	
	if ((PINA & (1 << PA7)) == 0) {
		BUTON_SUS = 1;
	}
}

/* reg 1 */
void output_led_state_re1(int poz_led){
	/* SH_CP low */
	PORTC &= ~(1 << PC2);
	
	/* ST_CP low */
	PORTC &= ~(1 << PC1);
	
	int i;
	for(i = 0; i < 8; i ++){
		/* aprind ledul de pe pozitia data ca paramentru */
		if (i == poz_led)
			PORTC |= (1 << PC0);
		else
			PORTC &= ~(1 << PC0);
		
		/* activare CLK - high */
		PORTC |= (1 << PC2);
		_delay_ms(20);
		
		/* low */
		PORTC &= ~(1 << PC2);
	}
	
	/* latch high */
	PORTC |= (1 << PC1);
}

/* reg 2 */
void output_led_state_reg2(int poz_led){
	/* SH_CP low */
	PORTC &= ~(1 << PC5);
	
	/* ST_CP low */
	PORTC &= ~(1 << PC4);

	int i;
	for(i = 0; i < 8; i ++){
		/* setez pe 1 pinul de pe pozitia data */
		if (i == poz_led)
			PORTC |= (1 << PC3);
		else
			PORTC &= ~(1 << PC3);
		
		/* CLK high */
		PORTC |= (1 << PC5);
		_delay_ms(20);
		
		/* CLK low */
		PORTC &= ~(1 << PC5);
	}
	PORTC |= (1 << PC6);
}

void output_linePortD(int poz){
	char[3] port;
	/* construire port */
	port[0] = "P";
	port[1] = "D";
		
	int i, line = 5 - poz;
	for (i = 1; i <= 5; i++){
		/* aprind linia data ca parametru */
		port[3] = i;
		if(line == i)
			PORTD |= (1 << port);
		else
			PORTD &= ~(1 << port);
	}
}

void output_linePortB(int poz){
	/* verificare manuala deoarece nu exista o regula la pini */
	if (poz == 5) {
		/* aprind linia data */
		PORTB |= (1 << PB7);
		
		/* restul liniilor pe 0 */
		PORTB &= ~(1 << PB6);
		PORTB &= ~(1 << PB5);
		PORTB &= ~(1 << PB4);
		PORTB &= ~(1 << PB3);
	}
	else if (poz == 6) {
			/* aprind linia data */
			PORTB |= (1 << PB6);
			
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			PORTB &= ~(1 << PB4);
			PORTB &= ~(1 << PB3);
		} else if (poz == 7) {
				/* aprind linia data */
				PORTB |= (1 << PB5);
				
				PORTB &= ~(1 << PB7);
				PORTB &= ~(1 << PB6);
				PORTB &= ~(1 << PB4);
				PORTB &= ~(1 << PB3);
				
				} else if (poz == 8) {
						/* aprind linia data */
						PORTB |= (1 << PB4);
						
						PORTB &= ~(1 << PB7);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB3);
						
						} else if (poz == 9){
							/* aprind linia data */
							PORTB |= (1 << PB3);
							
							PORTB &= ~(1 << PB7);
							PORTB &= ~(1 << PB6);
							PORTB &= ~(1 << PB5);
							PORTB &= ~(1 << PB4);
						}
}

/* metoda se asigura ca se sting toate ledurile */
void resetLiniiColoane(){
	PORTB &= ~(1 << PB7);
	PORTB &= ~(1 << PB6);
	PORTB &= ~(1 << PB5);
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB3);
	
	PORTD &= ~(1 << PD1);
	PORTD &= ~(1 << PD2);
	PORTD &= ~(1 << PD3);
	PORTD &= ~(1 << PD4);
	PORTD &= ~(1 << PD5);
	
	/* apelare metode cu pozitie invalida pentru e se seta valorile pe 0*/
	output_led_state_re1(10);
	output_led_state_reg2(10);
}

/* metoda modifica pozitiile snake pentru deplasare
   vefifcare daca se ajunge la pereti 
   verificare apasare butoane */
int nextPozSnake(){
	int i, new_x, new_y, aux_x, aux_y;
	
	/* verificare apsare butone */
	if (BUTON_JOS){
		new_x = poz_x[0] + 1;
		new_y = poz_y[0];
		
		for (i = 1; i < dimSnake - 1; i ++){
			poz_x[i] = poz_x[i + 1];
			poz_y[i] = poz_y[i + 1]; 
		}	
		
		poz_x[0] = new_x;
		poz_y[0] = new_x;
		BUTON_JOS = 0;
		
		if (miscareDreapta == 1 || miscareStanga == 1){
			/* actualizare miscare */
			miscareJos = 1;
			miscareDreapta = 0;
			miscareStanga = 0;
		}
	}
	
	if (BUTON_SUS){
		new_x = poz_x[0] - 1;
		new_y = poz_y[0];
		
		for (i = 1; i < dimSnake - 1; i ++){
			poz_x[i] = poz_x[i + 1];
			poz_y[i] = poz_y[i + 1];
		}
		
		poz_x[0] = new_x;
		poz_y[0] = new_x;
		BUTON_SUS = 0;
		
		if (miscareDreapta == 1 || miscareStanga == 1 ){
			/* actualizare miscare */
			miscareSus = 1;
			
			miscareDreapta = 0;
			miscareStanga = 0;
		}
	}
	
	if (BUTON_STANGA){
		new_x = poz_x[0];
		new_y = poz_y[0] - 1;
		
		for (i = 1; i < dimSnake - 1; i ++){
			poz_x[i] = poz_x[i + 1];
			poz_y[i] = poz_y[i + 1];
		}
		
		poz_x[0] = new_x;
		poz_y[0] = new_x;
		BUTON_STANGA = 0;
		
		/* daca miscare se facea in jos se schimba pozitia */
		if(miscareJos == 1 || miscareSus == 1){
			miscareJos = 0;
			miscareSus = 0;
			
			/* actualizare miscare */
			miscareStanga = 1;
		}
	}
	
	if (BUTON_DREAPTA){
		new_x = poz_x[0];
		new_y = poz_y[0] + 1;
		
		for (i = 1; i < dimSnake - 1; i ++){
			poz_x[i] = poz_x[i + 1];
			poz_y[i] = poz_y[i + 1];
		}
		
		poz_x[0] = new_x;
		poz_y[0] = new_x;
		BUTON_STANGA = 0;
		
		if (miscareJos == 1 || miscareSus == 1){
			/* actualizare miscare */
			miscareDreapta = 1;
			
			miscareJos = 0;
			miscareSus = 0;
		}
	}
	
	/* se modifica pozitia in functie ca capul sarpelui */
	/* in functie de cate rotiri a facut in directia accea continua */
	/* daca s-a apasat butonul de jos, miscarea continua in jos */
	if (miscareJos){
		new_x = poz_x[0] + 1;
		new_y = poz_y[0];
			
		for (i = 1; i < dimSnake - 1; i ++){
			poz_x[i] = poz_x[i + 1];
			poz_y[i] = poz_y[i + 1];
		}
			
		poz_x[0] = new_x;
		poz_y[0] = new_x;
		
	} else if (miscareDreapta) {
			new_x = poz_x[0];
			new_y = poz_y[0] + 1;
		
			for (i = 1; i < dimSnake - 1; i ++){
				poz_x[i] = poz_x[i + 1];
				poz_y[i] = poz_y[i + 1];
			}
		
			poz_x[0] = new_x;
			poz_y[0] = new_x;
			
			} else if (miscareStanga) {
					new_x = poz_x[0];
					new_y = poz_y[0] - 1;
					
					for (i = 1; i < dimSnake - 1; i ++){
						poz_x[i] = poz_x[i + 1];
						poz_y[i] = poz_y[i + 1];
					}
					
					poz_x[0] = new_x;
					poz_y[0] = new_x;
					
					} else if (miscareSus) {
								new_x = poz_x[0] - 1;
								new_y = poz_y[0];
							
								for (i = 1; i < dimSnake - 1; i ++){
									poz_x[i] = poz_x[i + 1];
									poz_y[i] = poz_y[i + 1];
								}
							
								poz_x[0] = new_x;
								poz_y[0] = new_x;
							}
	
	
	/* verificari pozitii dupa ce s-a efectuat urmatoarea miscare */
	if (poz_x[0] == -1 || poz_y[0] == -1)
		return 1;
	if (poz_x[0] == 10 || poz_y[0] == 10)
		return 1;
	
	return 0;
}

void Snake(){
	int i, press_b = 0, end_poz;
	
	while(1){
		
		/* parcurg pozitiile si prind ledurile */
		for (i = 0 ;i < dimSnake; i ++){
			/* verificare ce registru trebuie apelat */
			if (poz_x[i] <= 4) {
				/* apelare registru 1 cu pozitie valida */
				output_led_state_re1(poz_x[i]);
				
				/* apelare registru 2 cu pozitie nevalida, ca sa ramana toate coloanele pe 0 */
				output_led_state_reg2(10);
			} else 
				if (poz_x[i] >= 5){
					/* apelare registru 1 cu pozitie nevalida */
					output_led_state_re1(10);
					
					/* apelare registru 2 cu pozitia data */
					output_led_state_reg2(poz_x[i]);
				}
			
			/* verificare ce linie trebuie aprinsa */
			if (poz_y[i] <= 4) {
				output_linePortD(poz_y[i]);
				
				/* apelare metoda cu pozitie nevalida */
				output_linePortB(10);
			} else
				if (poz_y[i] >= 5) {
					output_linePortB(poz_y[i]);
					
					output_linePortD(10);
				}
				
			_delay_us(10);
			resetLiniiColoane();
		}
		
		press_button();
		end_poz = nextPozSnake();
		
		/* daca sarpele ajunge la unul din pereti jocul se termina */
		if (end_poz)
			break;
	}
}



int main(void) {
	
	/* apelez initierea */
	init();
	
	/* apelez crearea sarpelui */
	Snake();
	
	return 0;
}

